import base64

from cStringIO import StringIO
from string import split, rfind, strip, join

from zLOG import LOG, INFO

from Products.CMFNauTools.Heading import Heading
from Products.CMFNauTools.ZEOSyncer import ZEOSyncer

def do_XPublish( self ):
    """\
      CMFNauTools external publication
    """
    out = StringIO()

    out.write('ZEOPublishing start... \n')
    mount_point = ( self.portal_publisher.zeohost, 
                    self.portal_publisher.zeoport
                  )
##    mount_point = ('naumen', 5700)

    syncer = ZEOSyncer( self, mount_point )

    out.write('Mounted ZODB storage at %s:%d\n' % mount_point )

    objs = self.portal_catalog.searchResults( meta_type = 'HTMLDocument', 
                                              review_state = 'published' )

    out.write( '%d documents found\n' % len(objs) )

    transferred = 0

    for obj in objs:
       obj = obj.getObject()

       obj_path = join( obj.getPhysicalPath(), '/' )
       to_path = join( obj.aq_parent.getPhysicalPath(), '/' )

       # Transfer object to the given path 
       # on the remote server
       state = syncer.compare(obj_path, obj_path)
       if  state != 'ok':
           folder_classes = { 'Heading': Heading }
           syncer.transfer( obj, to_path, folder_classes )
      
           out.write('  %s (%s)\n' % (obj_path, state))
           transferred+=1

    out.write( '%d documents transferred\n' % transferred )

    return out.getvalue()
