import re

def HTMLCleaner(dirt_html, update_str=None, char_references_mode = 0, leave_str = '', remove_str = ''):
        if update_str is None:
            update_str = 'HTML HEAD TITLE \
                   BODY P width align height A href name target STRONG BR B I EM\
                   H1 H2 H3 H4 UL OL start LI\
                   TABLE bgcolor width border TH TBODY TR TD rowspan width bgcolor colspan\
                   IMG src width align height border PRE\
                   FONT color\
                   BLOCKQUOTE style'

        update_tags = {}

        tags_and_attrs = re.split('\s+', update_str)
        tagname = ''
        for tag_attr in tags_and_attrs:
                if tag_attr.upper() == tag_attr:
                        # tag_attr is tag name
                        update_tags[tag_attr] = []
                        tagname = tag_attr
                elif tagname != '':
                        #tag_attr is attribute name
                        update_tags[tagname].append(tag_attr)
        del (tags_and_attrs)

        if len(remove_str) > 0:
                remove_tags_content = re.split('\s+', remove_str)
        else:
                remove_tags_content = []

        if len(leave_str) > 0:
                leave_original = re.split('\s+', leave_str)
        else:
                leave_original = []

        dirt_html = re.sub(r"<!--.*?-->(?ms)", '', dirt_html)

        for tagname in remove_tags_content:
                pattern = r"<[\s]*" + tagname + r"[\s>]+.*?<[\s]*\/" + tagname + r"(>|\s+.*?>)(?si)"
                dirt_html = re.sub( pattern, '', dirt_html)

        tags_list = re.findall( r"<[\s]*\/?([\w\!]+).*?>(?si)", dirt_html )

        # 
        tmp = {}
        for tagname in tags_list:
                tmp[tagname] = 1
        tags_list = tmp.keys()
        del(tmp)

        tags_to_remove =[]

        for tagname in tags_list:
                if tagname.upper() not in (update_tags.keys()+leave_original):
                        tags_to_remove.append( tagname )

        for tagname in tags_to_remove:
                pattern = r"<\s*\/?" + tagname + r"(?:>|[\W]+?.*?>)(?msi)"
                dirt_html = re.sub(pattern, '', dirt_html)
        del (tags_to_remove)

        if char_references_mode == 0:
                pass
        elif char_references_mode == 1:
                pattern = r"&#?\w+?;(?ms)"
                dirt_html  = re.sub(pattern, '', dirt_html )
        elif char_references_mode == 2:
                pattern = r"(&#?\w+?;)\1+(?ms)"
                dirt_html = re.sub(pattern, r"\1", dirt_html )


        clean_html = dirt_html

        for tagname in update_tags.keys():
                pattern = r"(<\s*)(\/?)(" + tagname + r")(\s+.*?)>(?si)"
                tag_tuple_list = re.findall( pattern, dirt_html)
                for tag_tuple in tag_tuple_list:
                        tag_str = tag_tuple[0]+tag_tuple[1]+tag_tuple[2]+tag_tuple[3]+ ">"
                        tag_replace_str = "<" + tag_tuple[1] + tag_tuple[2]

                        attr_str = tag_tuple[3]+ " "

                        attrs_and_vals = re.findall(r"([a-zA-Z\-]+)\s*=\s*(?:([\"\'])(.*?)\2|([\w\-\.\%\#]+))(?si)", attr_str)

                        attrs_hash = {}
                        for prop in attrs_and_vals:
                                if prop[1]:
                                        attrs_hash[prop[0].lower()] = prop[1] + prop[2] + prop[1]
                                else:
                                        attrs_hash[prop[0].lower()] = prop[3]

                        # selected / checked flags
                        bool_attrs = re.findall(r"(?:(?<=^)|(?<=[^=]))\s+([a-zA-Z\-]+)(?=\s+(?:[^=]|$))(?si)", attr_str)
                        for prop in bool_attrs:
                                attrs_hash[prop.lower()] = ''

                        for attr_name in update_tags[ tagname ]:
                                if attrs_hash.has_key(attr_name):
                                        tag_replace_str += " " + attr_name
                                        if attrs_hash[attr_name] != '':
                                                tag_replace_str += "=" + attrs_hash[attr_name]
                        tag_replace_str += ">"

                        clean_html = clean_html.replace(tag_str, tag_replace_str)

        # empty strings cleanup
        clean_html = re.sub(r"^[\s]*[\r\n]+(?msi)", '', clean_html)

        return clean_html