import Globals
from Globals import InitializeClass, DTMLFile
from AccessControl import ClassSecurityInfo
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.Expression import Expression
from Products.CMFCore.utils import UniqueObject
from OFS.SimpleItem import SimpleItem

class HelpTool( UniqueObject, SimpleItem, ActionProviderBase ):

    id              = 'portal_help'
    meta_type       = 'NauSite Help Tool'
    _actions = [ActionInformation(id='about'
                            , title='About NauSite'
                            , action=Expression(
            text='string: ${portal_url}/about')
                            , permissions=(CMFCorePermissions.View,)
                            , category='help'
                            , condition=None
                            , visible=1
                             )] 

    security = ClassSecurityInfo()

    security.declarePrivate('listActions')
    def listActions(self, info=None):
        """
          Return actions provided by tool.
        """
        return self._actions


InitializeClass( HelpTool )
