from Products.CMFCore.utils import getToolByName
from Products.CMFCore.TypesTool import FactoryTypeInformation
from Products.CMFCore import DirectoryView
from Products.CMFCore.SkinsContainer import SkinsContainer 

from Globals import DTMLFile

import sys
from cStringIO import StringIO
from string import split, rfind, strip, join

class ManageCMFContent:
    """\
	A suite of methods deploying CMF site
    """

    def __init__(self, stream=None):
        """\
        stream is expected to be some writable file object,
        like a StringIO, that output will be sent to.
        """
	
	if stream is not None:
            self.stream = stream
	else:
            self.stream = StringIO()

    def deploy_class(self, target, type_name, fti):
        """\
	Register a new type
        """
        write = self.stream.write

        types_tool = getToolByName(target, 'portal_types')

	if not getattr( types_tool, type_name, None ):
	    fti = apply( FactoryTypeInformation
                       , ()
                       , fti[0]
                       )
	    types_tool._setObject( type_name, fti )
            write( 'Added type object for %s \n' % type_name )
        else:
            write( 'Skipping type object for %s (already exists) \n' % type_name )

    def register_view(self, target, view):
        """\
          Register a directory view
        """
        write = self.stream.write

        skins_tool = getToolByName(target, 'portal_skins')
        found = 0
	
        for dw in DirectoryView.manage_listAvailableDirectories():
          pos = rfind( dw, view )
          if pos > 0 and skins_tool._getOb(view, default=None) is None: 
              ## TODO: Replace '\' with '/'
              DirectoryView.manage_addDirectoryView( skins_tool, dw )
              write( 'Registered %s view\n' % view )
	      found = 1
	if not found: 
          write( 'Failed to register %s view (already exists?) \n' % view )
	  
	return view

    def set_skin(self, target, views, skin_name = 'Site', 
		    skin_path = 'custom, topic, content, generic, control, Images'):
        """\
          Create a new skin
        """
	self.skin_name = skin_name
	self.skin_path = skin_path

        skins_tool = getToolByName(target, 'portal_skins')
        skins =  skins_tool.getSkinPaths()

        include = ()
	found = 0
        for id, path in skins:
           if id == self.skin_name:
 	      paths = path.split(', ')
 	      include = filter( lambda x, cp=paths: x not in cp, views ) + paths
	      found = 1
	      
	if not found:
	   default_path = self.skin_path.split(', ')
	   include = views + default_path

        skins_tool.manage_properties( add_skin = 1
				    , skinname = self.skin_name
				    , skinpath = join(include, ', ')
				    ) 

	skins_tool.default_skin = self.skin_name
	
