import Globals

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Globals import DTMLFile

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.PortalFolder import PortalFolder
from Products.CMFCore.CMFCatalogAware import CMFCatalogAware
from Products.CMFCore.utils import _checkPermission, _getViewFor,getToolByName
from Products.CMFNauTools.ManageCMFContent import ManageCMFContent

from Acquisition import aq_parent, aq_inner, aq_base

factory_type_information = ( { 'id'             : 'NauBoard Container'
                             , 'meta_type'      : 'NauBoard Container'
                             , 'description'    : """\
CMF discussion board"""
                             , 'icon'           : 'board_icon.gif'
                             , 'product'        : 'CMFNauTools'
                             , 'factory'        : 'addBoardContainer'
                             , 'immediate_view' : 'nauboardcontainer_edit_form'
                             , 'allowed_content_types' :
                                ( 'NauBoard Item',
                                )
                             , 'actions'        :
                                ( { 'id'            : 'view'
				  , 'name'          : 'View'
                                  , 'action'        : 'nauboardcontainer_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , 
				  { 'id'            : 'edit'
				  , 'name'          : 'Edit'
                                  , 'action'        : 'nauboardcontainer_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                 ,
                                )
                             }
                           ,
                           )




class NauBoardContainer(CMFCatalogAware, PortalFolder, ManageCMFContent):
    """ Discussion board with message items """
    meta_type = 'NauBoard Container'
    portal_type = 'NauBoard Container'
    
    security = ClassSecurityInfo()

    def __init__( self, id, title='' ):
        self.id = id
        self.title = title
	self.indexObject()

    def __call__( self ):
        """
            Invoke the default action.
        """
        view = _getViewFor( self )
        if getattr( aq_base( view ), 'isDocTemp', 0 ):
            return apply( view, ( self, self.REQUEST ) )
        else:
            return view()

    index_html = None  # This special value informs ZPublisher to use __call__

    security.declareProtected( CMFCorePermissions.View, 'view' )
    def view( self ):
        """
            Return the default view even if index_html is overridden.
        """
        return self()

    def addBoardContainer( self      
                   , id              
                   , title=''        
                   ):                
        """                          
            Add a NauBoard Container 
        """                          
        o=NauBoardContainer( id=id   
                  , title=title      
                  )                  
        self._setObject(id, o)

    def addBoardItem( self, id, REQUEST = None ):
        """                          
            Add a new thread into the board
        """                          
        self.invokeFactory( 'NauBoard Item', id, REQUEST.RESPONSE )

    ### Content accessor methods
    security.declareProtected(CMFCorePermissions.View, 'SearchableText')
    def SearchableText(self):
        """ 
            Used by the catalog for basic full text indexing 
        """
        return "%s %s %s" % ( self.Title()
                            )

Globals.InitializeClass(NauBoardContainer)

def install(target):
     """\
        Registering NauBoard Container class
     """
     Installer = ManageCMFContent()

     Installer.deploy_class( target=target
                      , type_name='NauBoard Container'
                      , fti=factory_type_information
                      )

addBoardContainer = NauBoardContainer.addBoardContainer
addBoardContainerForm = DTMLFile( 'nauboardcontainer_edit_form', globals() )

