import Globals
from Products.CMFDefault.NewsItem import NewsItem
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Products.CMFCore.utils import getToolByName
from Products.CMFNauTools.ManageCMFContent import ManageCMFContent

from Products.CMFCore import CMFCorePermissions


factory_type_information = ( { 'id'             : 'NauBoard Item'
                             , 'meta_type'      : 'NauBoard Item'
                             , 'description'    : """\
  """
                             , 'icon'           : 'newsitem_icon.gif'
                             , 'product'        : 'CMFNauTools'
                             , 'factory'        : 'addBoardItem'
                             , 'immediate_view' : 'nauboarditem_edit_form'
                             , 'allow_discussion' : 1
                             , 'global_allow'   : 0  
                             , 'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'nauboarditem_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'newsitem_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                )
                             }
                           ,
                           )


def addBoardItem( self
               , id
               , title=''
               , description=''
               , text=''
               , text_format='html'
               ):
    """
        Add a NauBoard Item
    """
    o=NauBoardItem( id=id
              , title=title
              , description=description
              , text=text
              , text_format=text_format
              )
    self._setObject(id, o)


class NauBoardItem(NewsItem, ManageCMFContent):
    """ 
       Board item. This is actually a NewsItem
    """
    meta_type = 'NauBoard Item'
    security = ClassSecurityInfo()
    _isDiscussable = 1

Globals.InitializeClass(NauBoardItem)

def install(target):
     """\
        Registering NauBoard Container class
     """
     Installer = ManageCMFContent()

     Installer.deploy_class( target=target
                      , type_name='NauBoard Item'
                      , fti=factory_type_information
                      )

     workflow_tool = getToolByName(target, 'portal_workflow')

     # Erase the workflow actions for discussion items
     workflow_tool.setChainForPortalTypes( ( 'Discussion Item', ), () )
     workflow_tool.setChainForPortalTypes( ( 'NauBoard Item', ), () )
