import Globals
from Products.CMFDefault.Image import Image
from Products.CMFCore import CMFCorePermissions
from SimpleNauItem import SimpleNauItem 
from Products.CMFCore.utils import getToolByName

factory_type_information = ( { 'id'             : 'Site Image'
                             , 'meta_type'      : 'Site Image'
                             , 'description'    : """\
Image objects can be embedded in Portal documents and added to the external sites."""
                             , 'icon'           : 'image_icon.gif'
                             , 'product'        : 'CMFNauTools'
                             , 'factory'        : 'addSiteImage'
                             , 'immediate_view' : 'metadata_edit_form'
                             , 'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'image_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'image_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                , { 'id'            : 'metadata'
                                  , 'name'          : 'Metadata'
                                  , 'action'        : 'metadata_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                )
                             }
                           ,
                           )

import OFS.Image

def addSiteImage( self
            , id
            , title=''
            , file=''
            , content_type=''
            , precondition=''
            , subject=()
            , description=''
            , contributors=()
            , effective_date=None
            , expiration_date=None
            , format='image/png'
            , language=''
            , rights=''
            ):
    """
        Add a Site Image (based on Image.addImage)
    """

    # cookId sets the id and title if they are not explicity specified
    id, title = OFS.Image.cookId(id, title, file)

    self=self.this()

    # Instantiate the object and set its description.
    iobj = SiteImage( id, title, '', content_type, precondition, subject
                , description, contributors, effective_date, expiration_date
                , format, language, rights
                )
    
    # Add the Image instance to self
    self._setObject(id, iobj)

    # 'Upload' the image.  This is done now rather than in the
    # constructor because it's faster (see File.py.)
    self._getOb(id).manage_upload(file)

class SiteImage( SimpleNauItem, Image ):
    meta_type='Site Image'
    
    def manage_afterAdd(self, item, container):

        # Automatically publish object in case it 
        # is added inside the SiteContainer instance
        workflow = getToolByName(self, 'portal_workflow')
        if hasattr(container, 'ext_link') and workflow.getInfoFor(self, 'review_state', '') != 'published':
           workflow.doActionFor( item, 'publish', comment='Published by NauSite' )

        Image.manage_afterAdd(self, item, container)

Globals.InitializeClass(SiteImage)
