from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from ZClasses import createZClassForBase
from Products.CMFCore.MemberDataTool import MemberData

import Globals
import ManageCMFContent
import ForestTag
import GroupsTool, NauMetadataTool, NauPublishTool, HelpTool, NauSite
import HTMLCleanup
import sys
from zLOG import LOG, INFO

this_module = sys.modules[ __name__ ]

nau_globals = globals()

LOG( 'CMFNauTools.__init__', INFO, 'Patching MemberDataTool')


MemberData.setMemberProperties__roles__ = ('Manager',)
MemberData.setSecurityProfile__roles__ = ('Manager',)

ADD_CONTENT_PERMISSION = 'View'

bases = (NauBoardItem.NauBoardItem,)
tools = ( GroupsTool.GroupsTool
        , NauMetadataTool.NauMetadataTool
        , NauPublishTool.NauPublishTool
        , HelpTool.HelpTool
        )

# Deriving nauboardItem from ZClass
for base in bases:
    createZClassForBase( base, this_module )

# Make skins available as DirectoryViews
registerDirectory('skins', globals())
registerDirectory('skins/gui', globals())
registerDirectory('skins/common', globals())
registerDirectory('skins/nauboard', globals())
registerDirectory('skins/discussions', globals())
registerDirectory('skins/htmldocument', globals())
registerDirectory('skins/vote', globals())
registerDirectory('skins/heading', globals())
registerDirectory('skins/groups', globals())
registerDirectory('skins/mail_templates', globals())
registerDirectory('skins/site_mandatory', globals())
registerDirectory('skins/site_common', globals())
registerDirectory('skins/site_images', globals())

z_tool_bases = utils.initializeBasesPhase1( tools, this_module )
         
def initialize(context):

    context.registerClass(NauSite.NauSite,
                          constructors = (NauSite.manage_addNauSiteForm,
                                          NauSite.manage_addNauSite),
                          icon = 'icons/nausite.gif')    

    utils.initializeBasesPhase2( z_tool_bases, context )

    utils.ToolInit('CMF Nau Tools', 
                   tools=tools,
                   product_name='CMFNauTools', icon='tool.gif',
                   ).initialize( context )

    utils.ContentInit( 'CMF Nau Content'
                     , content_types=( NauBoardItem.NauBoardItem
                                     , NauBoardContainer.NauBoardContainer
                                     , HTMLDocument.HTMLDocument
                                     , DTMLDocument.DTMLDocument
                                     , Vote.Vote
                                     , Heading.Heading
                                     , Report.Report
                                     , NauPublishTool.NauPublisher
                                     , Site.SiteContainer
                                     , SiteImage.SiteImage,
                                     )
                     , permission=ADD_CONTENT_PERMISSION
                     , extra_constructors=( NauBoardItem.addBoardItem
                                          , NauBoardContainer.addBoardContainer
                                          , HTMLDocument.addHTMLDocument
                                          , DTMLDocument.addDTMLDocument
                                          , Vote.addVote
                                          , Heading.addHeading
                                          , Report.addReport
                                          , NauPublishTool.manage_addNauPublisher
                                          , Site.addSiteContainer
                                          , SiteImage.addSiteImage,
                                          )
                     , fti=NauSite.factory_type_information
                     ).initialize( context )

    context.registerHelpTitle( 'NauSite Help' )
    context.registerHelp( directory='help' )
