## Script (Python) "content_status_modify"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=workflow_action, comment='', requested_users=None, confirm_by_turn=0
##title=Modify the status of a content object
##
REQUEST = context.REQUEST

review_state = context.portal_workflow.getInfoFor(context, 'review_state', '')

# Send publication announcement to subscribed users
if workflow_action == 'publish' and context.getSite() is not None:
    context.announce_publication(context, REQUEST=REQUEST)

# Reset site home page
if context.isHomePage() and context.getSite() is not None:
   context.setHomePage(ob=None)

# Document was in a 'confirmation pending' state
if review_state == 'pending':
    # Cancel confirmation request
    context.cancelConfirmationRequest(comment)

if requested_users:
     # Document review is required, switch to 
     # the 'confirmation pending' state
     workflow_action = 'submit'
     
     try:
        context.manage_addProperty('requested_users', '', 'lines' )
        context.manage_addProperty('confirmed_users', '', 'lines' )
        context.manage_addProperty('confirm_by_turn', 0, 'int' )
     except:
        pass

     context.manage_changeProperties(confirm_by_turn=confirm_by_turn)
     context.manage_changeProperties(requested_users=requested_users)
     context.manage_changeProperties(confirmed_users='')
     context.requestConfirmation(requested_users, confirm_by_turn, comment)

# Invoke workflow action
context.portal_workflow.doActionFor(
    context,
    workflow_action,
    comment=comment)

try:
  context.reindexObject()
except:
  pass

redirect_url = '%s/view?%s' % ( context.absolute_url()
                                  , 'portal_status_message=State+changed'
                                  )

context.REQUEST[ 'RESPONSE' ].redirect( redirect_url )
