## Script (Python) "metadata_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=id,title=None,subject=None,description=None,contributors=None,effective_date=None,expiration_date=None,format=None,language=None,rights=None,type_name=None
##title=Update Content Metadata
##
def tuplify( value ):

    if not same_type( value, () ):
        value = tuple( value )

    temp = filter( None, value )
    return tuple( temp )

if type_name:
   context.invokeFactory( id = id
                        , type_name = type_name
                        )
   obj = context[id]
else:
   obj = context

if title is None:
    title = obj.Title()

if subject is None:
    subject = obj.Subject()
else:
    subject = tuplify( subject )

if description is None:
    description = obj.Description()

if contributors is None:
    contributors = obj.Contributors()
else:
    contributors = tuplify( contributors )

if effective_date is None:
    effective_date = obj.EffectiveDate()

if expiration_date is None:
    expiration_date = obj.expires()

if format is None:
    format = obj.Format()

if language is None:
    language = obj.Language()

if rights is None:
    rights = obj.Rights()

obj.editMetadata( title=title
                    , description=description
                    , subject=subject
                    , contributors=contributors
                    , effective_date=effective_date
                    , expiration_date=expiration_date
                    , format=format
                    , language=language
                    , rights=rights
                    )

if obj.REQUEST.get( 'change_and_edit', 0 ):
    action_id = 'edit'
elif obj.REQUEST.get( 'change_and_view', 0 ):
    action_id = 'view'
else:
    action_id = 'metadata'

action_path = obj.getTypeInfo().getActionById( action_id )

action_method = obj.restrictedTraverse( action_path )

return action_method( obj
                    , context.REQUEST
                    , portal_status_message='Metadata changed'
                    )
