## Script (Python) "register"
##bind container=container
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=traverse_subpath
##parameters=password='password', confirm='confirm', groups=[], roles=[]
##title=Register a user
##
REQUEST=context.REQUEST
portal_properties = context.portal_properties
portal_registration = context.portal_registration

if not REQUEST.get('email', ''):
   return context.join_form( context, REQUEST, error='  e-mail  ' )
 
if not portal_properties.validate_email:
  failMessage = portal_registration.testPasswordValidity(password, confirm)
  if failMessage:
      REQUEST.set( 'error', failMessage )
      return context.join_form( context, REQUEST, error=failMessage )
      
failMessage = portal_registration.testPropertiesValidity(REQUEST)
if failMessage:
    REQUEST.set( 'error', failMessage )
    return context.join_form( context, REQUEST, error=failMessage )
else:
    username = REQUEST['username']
    password=REQUEST.get('password') or portal_registration.generatePassword()

    if REQUEST.get('asManager', ''):
       roles = ('Manager', )

    portal_registration.addMember(username, password, roles = ('Member',) + tuple(roles), properties=REQUEST)

    portal = context.portal_url.getPortalObject()

    for group in groups:
        group_users = list( context.portal_groups.group_users(group) )
        group_users.append( username )
        context.portal_groups.changeGroup( group, group_users )

    if portal_properties.validate_email or REQUEST.get('mail_me', 0) or not REQUEST.get('password'):
        portal_registration.registeredNotify(REQUEST['username'])

    if not REQUEST.get('noHome', 0):
        username = REQUEST['username']
        members = context.portal_url.getPortalObject().storage.members
        try:
          members.manage_addHeading(id=username, title=REQUEST.get('home', ''))
          members[username].manage_setLocalRoles(username, ['Owner'])
        except:
          pass

        if not REQUEST.get('noDefaults', 0):
            try:
              obs = members.user_defaults.manage_copyObjects(members.user_defaults.objectIds())
              members[username].manage_pasteObjects(obs)
            except:
              pass

    return context.registered( context, REQUEST )
