## Script (Python) "document_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST, RESPONSE, text_format, text=' ', SafetyBelt='', poll='', file='', doc_type=None, deletefile, pastefile, attach=None, noWYSIWYG=0, log_message=''
##title=Edit a document
##
message='Document+saved.'

text = context.cleanup( text )

if attach and attach.filename:
    text = context.addFile(attach, text + ' ')


if pastefile:
    id = REQUEST['pastefile']
    # 'size' is used while generating an image preview thumbnail
    size = REQUEST.get('%s_size' % id, None)
    text = context.pasteFile(pastefile, text + ' ', size)

if deletefile:
    text = context.deleteFile(deletefile, text + ' ')

if text:
    # Apply document changes
    context.edit(text_format,
                 text,
                 file,
                 safety_belt=SafetyBelt)

    # Update the document 'modification' date
    context.setEffectiveDate(DateTime())

    username = context.portal_membership.getAuthenticatedMember().getUserName()

    if log_message:
        ts = str(int(DateTime()))
        context.changes_log.append( { 'date'   : ts
                                    , 'member' : username
                                    , 'comment': log_message
                                    } )
else: 
    message='Can\' save document'

if not context.hasProperty('poll'):
    context.manage_addProperty('poll','','string')

try:    
  # Only owner can change document settings
  if poll:
     context.manage_changeProperties( {'poll': poll} )
  else:
     context.manage_changeProperties( {'poll': ''} )
   
  if not context.hasProperty('comment_type'):
     context.manage_addProperty('comment_type',0,'int')
    
  context.manage_changeProperties( {'comment_type': comment_type} )

  if not context.hasProperty('last_comment'):
     context.manage_addProperty('last_comment',1,'int')
except:
  # Group document, don't change settings
  pass

qst='?portal_status_message='+message

if noWYSIWYG:
   qst+='&noWYSIWYG=1'

context.REQUEST.RESPONSE.redirect( context.absolute_url() + '/document_edit_form' + qst )
