#$Id: DTMLDocumentTests.py,v 1.6 2002/08/22 12:24:24 kfirsov Exp $
from ZopeTest import ZopeTestCase
import re

class DummyWithContent:
	filename = None
	content = None
	
	def __init__(self, fn='just/test.txt', cnt=''):
	        self.filename=fn
	        self.content=cnt;

	def seek(t, a=None, b=None): pass
	def write(t): pass
	def close(): pass
	def fileno(): raise 'this sux'
	def flush(): pass
	def read(self, a=None, b=None): return self.content
	def readline(): return ''
	def readlines(): return []
	def tell(t=None): return 0
	def truncate(i): pass
	def writelines(i): pass


class DTMLDocumentTestCase(ZopeTestCase):

	doc_id = ''
	
	def setUp(self):
		from Products.CMFNauTools import DTMLDocument
		import random
		ID = 'd'
		while getattr(self.app.docs.storage, ID, None):
			ID = 'test_dtml_' + str( random.randrange(1000000) )

		self.app.docs.storage.manage_addProduct['CMFNauTools'].addDTMLDocument(ID, 
						title='title', file='', REQUEST=None, submit=None)
		d = getattr(self.app.docs.storage, ID)
		self.assert_(d, 'AddDTMLDocument Error' )
		self.doc_id = ID
                
	def tearDown(self):
		self.app.docs.storage.manage_delObjects(self.doc_id)
		
	def testEdit(self):
		d = getattr(self.app.docs.storage, self.doc_id)
		d.edit('new_title', 'new_data')
		self.assertEqual( d.title, 'new_title', 'Error editing title')
		self.assertEqual( str(d), 'new_data', 'Error editing contents')
		
	def testView(self):
		#Not implemented
		#The problem is 'view' method is called only from NauSite user interface 
		# (and is not called by default)
		pass
	
	def testUpload(self):
		d = getattr(self.app.docs.storage, self.doc_id)
		f = DummyWithContent("dummy.dtml", "<body></body>")
		d.upload(f)
		self.assertEqual( str(d), '&lt;body&gt;&lt;/body&gt;', 'Error uploading file')
		
