"""ManageCMFContent class XP test.

$Id: ManageCMFContentTests.py,v 1.2 2002/08/26 04:47:03 ikuleshov Exp $
"""
__version__='$ $'[11:-2]

from ZopeTest import ZopeTestCase
from string import join

factory_type_information = ( { 'id'             : 'FakeType'
                             , 'meta_type'      : 'FakeType'
                             , 'description'    : """\
This is a fake type created by ManageCMFContent class XP test"""
                             , 'product'        : ''
                             , 'factory'        : ''
                             , 'filter_content_types' : 0
                             , 'immediate_view' : ''
                             , 'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : ''
                                  , 'category'      : 'folder'
                                  },
                                )
                             }
                           ,
                           )


class ManageCMFContentTests(ZopeTestCase):
    id = 'ManageCMFContentZopeTest'

    def setUp(self):
        get_transaction().begin()
        self.target = self.app.docs

    def testTypes(self):
        from Products.CMFNauTools.ManageCMFContent import ManageCMFContent
        from Products.CMFCore.utils import getToolByName

	# init the installer
        Installer = ManageCMFContent()

        # add 'FakeType' to the CMF portal
        Installer.deploy_class( target=self.target
                              , type_name='FakeType'
                              , fti=factory_type_information
                              )

        # get the 'FakeType' details
        portal_types = getToolByName(self.target, 'portal_types')
        ti = portal_types.getTypeInfo('FakeType')

	# check we got the TypeFactoryInformation instance, not None
	assert( ti is not None )
	assert( ti.Description() == factory_type_information[0]['description'] )

    def testSkins(self):
        from Products.CMFNauTools.ManageCMFContent import ManageCMFContent
        from Products.CMFCore.utils import getToolByName
        from Products.CMFCore.DirectoryView import registerDirectory

        registerDirectory('../fake_skin/fake_dw', globals())

	# init the installer
        Installer = ManageCMFContent()
        Installer.register_view(self.target, 'fake_dw')
	Installer.set_skin(target = self.target
	                  , views = ['fake_dw',]
			  , skin_name = 'Fake'
			  , skin_path = 'fake_dw'
			  )
	# check that skin sample dtml is available 
        # through the global CMF namespace
	assert( self.app.docs.fake_form )
	
    def tearDown(self):
        get_transaction().abort()
