"""

$Id: NauMetadataToolTests.py,v 1.8 2002/08/23 09:44:54 kfirsov Exp $
"""
__version__='$ $'[11:-2]


from ZopeTest import ZopeTestCase

class NauMetadataToolTests(ZopeTestCase):
	
	port_met = None
	def setUp(self):
		from Products.CMFCore.utils import getToolByName
		self.port_met = getToolByName(self.app.docs, 'portal_metadata')

	def testListActions(self):
		""" this test is very hard for realized ;) """
		#print self.port_met.listActions()
		pass

	
	
	def testGetSetSpecVocabulary(self):
		import random
		from Products.CMFNauTools import HTMLDocument
	        from Products.CMFCore.utils import getToolByName
	        		
		meta = self.port_met
		new_typ = 'New type'
		test_vocabulary = ['123', '321']
		new_voc = ['New', 'vocabulary', 'test']

		el_id = 'Subject'

		while 1:
			try:	meta.getElementSpec( el_id )
			except KeyError:	break
			el_id = 'ElSpec_' + str( random.randrange(1000000) )

		#create new elementSpec into portal_metadata
		#and add policy with allowed_vocabulary=new_voc
		meta.addElementSpec( el_id, 1)
		elementSpec = meta.getElementSpec( el_id )
		
		policies_types = apply(zip, elementSpec.listPolicies())[0]
		while new_typ in policies_types:
			new_typ = 'New type_' + str( random.randrange(1000000) )
			
		elementSpec.addPolicy(new_typ)
		policy = elementSpec.getPolicy( new_typ )
		policy.edit( policy.isRequired(), 
				policy.supplyDefault(), 
				policy.defaultValue(),
				policy.enforceVocabulary(),
				new_voc)
		
		# now test getSpecVocabulary()
		self.assertEqual( policy.allowedVocabulary(), 
				meta.getSpecVocabulary(el_id, new_typ), 
				'getSpecVocabulary() returned invalid vocabulary')
		
		# testing setSpecVocabulary()
		meta.setSpecVocabulary(el_id, new_typ, allowed_vocabulary=test_vocabulary)
		self.assertEqual(policy.allowedVocabulary(), tuple(test_vocabulary), \
				'setSpecVocabulary() did not change vocabulary' )
		
		
		
		#if there is no element 'Subject', further test has no sence :-)
		if el_id == 'Subject':
			elementSpec.removePolicy(new_typ)
			return
		
		#delete ElementSpec we created
		meta.removeElementSpec( el_id )

		el_id = 'Subject'
		
		#create new policy for 'Subject' with new vocabulary
		
		subj_element = meta.getElementSpec( el_id )
		subj_policies = subj_element.listPolicies()
		
		#select type not presented in subj_policies :
		policies_types = apply(zip, subj_policies)[0]
		while new_typ in policies_types:
			new_typ = 'New type_' + str( random.randrange(1000000) )
		
		#add new policy with new vocabulary
		subj_element.addPolicy( new_typ )
		
		new_typ_policy = subj_element.getPolicy( new_typ )
		new_typ_policy.edit( new_typ_policy.isRequired(), 
				new_typ_policy.supplyDefault(), 
				new_typ_policy.defaultValue(),
				new_typ_policy.enforceVocabulary(),
				new_voc)

		#have to create new document with Subject=new_voc[0] to test setSpecVocabulary
		existed_obj = self.app.docs.storage.objectIds()
		temp_doc_id = 'temp'
		while temp_doc_id in existed_obj:
			temp_doc_id = 'temp_' + str( random.randrange(1000000) )
		self.app.docs.storage.manage_addProduct['CMFNauTools'].addHTMLDocument(temp_doc_id, 
			title='title', description='decs', text_format='html', text='')
		temp_doc = getattr(self.app.docs.storage, temp_doc_id)
		# allow us to find this document thrue ZCatalog.searchResults()
		temp_doc.setLocalRoles('Anonymous User', ['Reviewer'])
		temp_doc.editMetadata(subject=new_voc[0])
	        
		
		
		#setSpecVocabulary(el_id, new_typ, allowed_vocabulary=[...]) must 
		# append new_voc[0] in allowed_vocabulary before changing 
		# policy's vocabulary
		meta.setSpecVocabulary(el_id, new_typ, allowed_vocabulary=[ new_voc[1] ])
		voc_from_getVoc = list(meta.getSpecVocabulary(el_id, new_typ))
		voc_from_getVoc.sort()
		voc_to_compare = new_voc[0:2]
		voc_to_compare.sort()
	        self.assertEqual ( voc_from_getVoc, voc_to_compare, '')
		
		#delete all we've created
		subj_element.removePolicy( new_typ )