"""Report class XP test.

$Id: ReportTests.py,v 1.9 2002/08/20 14:51:04 ikuleshov Exp $
"""
__version__='$ $'[11:-2]

from ZopeTest import ZopeTestCase

class ReportTests(ZopeTestCase):
    def setUp(self):
        from Products.CMFNauTools.Report import Report
        from DateTime import DateTime

        self.app.docs.storage.d = Report('foo')

	d = self.app.docs.storage.d
        d.config( title='foo title'
                , expiration_date=DateTime('2003/12/25')
                , description='foo description'
                , resp_groups=[]
                , resp_members=['user1', 'user2']
                )

    def testConfigMain(self):
	d = self.app.docs.storage.d
        assert d

        self.validateConfig()

    def testConfigReportsForm(self):
        from DateTime import DateTime
        from Testing.makerequest import makerequest
        from sys import stderr
        import Zope

	d = self.app.docs.storage.d

        reportconf = d.propertysheets.get('reportconf')
        typeOf = reportconf.getPropertyType
        hasField = reportconf.hasProperty

        self.addReportField('string_field', 'string')
        assert( hasField('string_field') )
        assert( typeOf('string_field') == 'string')

        self.addReportField('date_field', 'date')
        assert( hasField('date_field') )
        assert( typeOf('date_field') == 'date')

        self.addReportField('boolean_field', 'boolean')
        assert( hasField('boolean_field') )
        assert( typeOf('boolean_field') == 'boolean')

        self.addReportField('text_field', 'text')
        assert( hasField('text_field') )
        assert( typeOf('text_field') == 'text')

        self.addReportField('int_field', 'int')
        assert( hasField('int_field') )
        assert( typeOf('int_field') == 'int')

        self.addReportField('float_field', 'float')
        assert( hasField('float_field') )
        assert( typeOf('float_field') == 'float')

        self.validateConfig()

        assert (not d.reportCount())

        app = makerequest(Zope.app(), stderr)
        REQUEST = app.REQUEST

        REQUEST['string_field'] = 'foo string'
        REQUEST['text_field'] = 'foo\n text'
        REQUEST['int_field'] = '4567'
        REQUEST['float_field'] = '4567.8900'
        REQUEST['boolean_field'] = 1
        REQUEST['date_field_year'] = 2003
        REQUEST['date_field_month'] = 'jan'
        REQUEST['date_field_day'] = 1
        REQUEST['date_field_hour'] = 12
        REQUEST['date_field_min'] = 30

        d.addReport(uname='user1', REQUEST=REQUEST)

        assert (d.reportCount() == 1)

        report1 = d.reports()[0]

        assert( report1['Creator'] == 'user1' )
        assert( report1['string_field'] == 'foo string' )
        assert( report1['text_field'] == 'foo\n text' )
        assert( report1['int_field'] == 4567 )
        assert( report1['float_field'] == 4567.89 )
        assert( report1['boolean_field'] )
        assert( report1['date_field'] == DateTime('2003/jan/01 12:30') )

        self.delReportField('date_field')
        assert( hasField('string_field') )
        assert( not hasField('date_field') )

        self.addReportField('new_date_field', 'date')
        assert( hasField('new_date_field') )
        assert( typeOf('new_date_field') == 'date')
        REQUEST['reportitem_%s_%i' % (report1['Creator'], int(report1['TimeStamp']))] = 1
        d.delReport( REQUEST )

        assert (d.reportCount() == 0)

    def validateConfig(self):
        from DateTime import DateTime

	d = self.app.docs.storage.d

        assert( 'user1' in d.involvedUsers() )
        assert( 'user2' in d.involvedUsers() )

        assert( d.resp_members == ['user1', 'user2'] )
        assert( d.resp_groups == [] )

        assert( d.get_local_roles_for_userid('user1') == ('Reader',))
        assert( d.get_local_roles_for_userid('user2') == ('Reader',))
        assert( not d.get_local_roles_for_userid('user3') )

        assert( d.expiration_date == DateTime('2003/12/25') )
        assert( d.title == 'foo title' )
        assert( d.description == 'foo description' )

    def addReportField(self, fname, ftype):
        REQUEST = self.app.REQUEST
        REQUEST['add_field'] = 1
        REQUEST['fname'] = fname
        REQUEST['ftype'] = ftype

	d = self.app.docs.storage.d

        d.config( title=d.title
                , expiration_date=d.expiration_date
                , description=d.description
                , resp_groups=d.resp_groups
                , resp_members=d.resp_members
                , REQUEST=REQUEST
                )


    def delReportField(self, fname):
        from Testing.makerequest import makerequest
        from sys import stderr
        import Zope

        app = makerequest(Zope.app(), stderr)

        REQUEST = app.REQUEST
        REQUEST['del_fields'] = 1
        REQUEST[fname] = 1

	d = self.app.docs.storage.d

        d.config( title=d.title
                , expiration_date=d.expiration_date
                , description=d.description
                , resp_groups=d.resp_groups
                , resp_members=d.resp_members
                , REQUEST=REQUEST
                )

        # cleanup REQUEST
        #
        REQUEST['del_fields'] = None
        REQUEST[fname] = None
