"""SiteContainer class XP test.

$Id: SiteContainerTests.py,v 1.3 2002/08/22 06:13:22 ikuleshov Exp $
"""
__version__='$ $'[11:-2]

from ZopeTest import ZopeTestCase
from string import join

class SiteContainerTests(ZopeTestCase):
    user = 'tester'
    password = '123'
    id = 'SiteContainerZopeTest'

    def setUp(self):
        from Products.CMFNauTools.Site import SiteContainer
        from Products.CMFCore import utils

        get_transaction().begin()
        storage = self.app.docs.storage

    def testSite(self):
        storage = self.app.docs.storage

        try: self.app.docs.storage[self.id].delete_me()
        except: pass

        storage.manage_addProduct['CMFNauTools'].manage_addHeading(id=self.id)

        h = storage[self.id]
	storage.setLocalRoles('Anonymous User', ['Manager', 'Owner'])

        h.manage_addProduct['CMFNauTools'].manage_addHeading(id='storage')
        h.manage_addProduct['CMFNauTools'].manage_addHeading(id='test_external')
        h.manage_addProduct['CMFNauTools'].manage_addSiteContainer( id='foo'
                                                                  , title='Foo Site'
                                                                  , skin_links=['portal_skins/images', 'portal_skins/custom']
                                                                  , repository_url =  join(h.getPhysicalPath(), '/') + '/test_external'
                                                                  , storage_id = 'test_storage'
                                                                  )
        # Check existence and settings of the 'Site Container' object
        assert( hasattr(h, 'foo') )
        foo = h['foo']

        assert( foo.meta_type == 'Site Container' )
        assert( foo.title == 'Foo Site' )

        # Verify links and document storage creation
        assert( hasattr(foo.aq_self, 'custom') )
        assert( len(foo['custom'].objectIds()) )

        assert( hasattr(foo.aq_self, 'images') )
        assert( len(foo['images'].objectIds()) )

        assert( hasattr(foo.aq_self, 'test_storage') )
        assert( not len(foo['test_storage'].objectIds()) )

        # Verify external site creation
        assert( hasattr(h, 'test_external') )
        external = h['test_external']

        assert( hasattr(external, 'foo') )

        site = external['foo']
        assert( site.meta_type == 'CMF Site' )

        # Check that Publisher EP is exist and set up properly
        assert( hasattr(site, 'go') )
        publisherEP = site['go']
        assert( publisherEP.meta_type == 'Publisher Entry Point' )
        assert( publisherEP.internal == join(foo.getPhysicalPath(), '/') + '/test_storage' )

    def tearDown(self):
        self.app.docs.storage.manage_delObjects(self.id)
  
        get_transaction().abort()
