"""TaskContainer/TaskItem class XP test.

$Id: TaskItemTests.py,v 1.3 2002/08/23 11:09:22 and Exp $
"""
__version__='$ $'[11:-2]

from ZopeTest import ZopeTestCase
from string import join

class TaskContainerTests(ZopeTestCase):
    id = 'TaskContainerZopeTest'
    user = 'Anonymous_User'
    password = ''

    def setUp(self):
        get_transaction().begin()
        storage = self.app.docs.storage
        storage.manage_addProduct['CMFNauTools'].addHTMLDocument(id=self.id)

    def test(self):
        from DateTime import DateTime
        from AccessControl.SecurityManagement import newSecurityManager

        # Create a new test portal member and update security policy
	self.app.docs.acl_users._doAddUser(self.user, self.password, ['Manager'], '')
        newSecurityManager(self.app.REQUEST, self.app.docs.acl_users.getUser(self.user) )

        html_doc = self.app.docs.storage[self.id]
        html_doc.getTasksFor(html_doc)

        # check that TaskContainer object has been added
        assert( hasattr(html_doc, 'followup') )

        reportID = html_doc.followup.createTask(  title='foo task'
                                               ,  description='foo description'
                                               ,  expires=DateTime('2002/01/01')
					       ,  Creator=self.user
                                               ,  inspector=self.user
                                               ,  resp_groups=[]
                                               ,  resp_members=[self.user,]
                                               )

        # check whether the TaskContainer has task with id reportID
	assert( reportID in html_doc.followup.getRepliesIds() )

        task = html_doc.followup.getReply( reportID )


        ## print self.app.docs.portal_membership.getAuthenticatedMember().getUserName()

        # commit to a task and find the user in the list of committed users
        task.commit('Committed to a test')
        assert( self.user in html_doc.followup.involvedUsersFor(task, status=1) )

        # reject a task and find the user in the list of rejected users
        task.reject('Rejected a test')
        assert( self.user in html_doc.followup.involvedUsersFor(task, status=2) )

        # create a subtask in the context of 'task'
        subreportID = html_doc.followup.__of__(task).createTask(  title='bar subtask'
                                                               ,  description='bar description'
                                                               ,  expires=DateTime('2002/01/01')
                                                               ,  resp_groups=[]
                                                               ,  resp_members=[self.user,]
                                                               )

        # check whether the TaskContainer has task with id reportID
	assert( subreportID in html_doc.followup.getRepliesIds() )
        subtask = html_doc.followup.getReply( subreportID )

        # check that subtask has reviewer's comment
        subtask.review('Reviewed a test')
        assert( subtask.comment('_inspector') )

        # close task and assure that subtask was closed too
        task.close('Test is closed')
        assert( task.isClosed() )
        assert( subtask.isClosed() )

        # delete task
        task.delete_me()
        # check whether the TaskContainer has no task with id reportID
	assert( reportID not in html_doc.followup.getRepliesIds() )

    def tearDown(self):
        self.app.docs.storage.manage_delObjects(self.id)
  
        get_transaction().abort()
