#$Id:  Exp $
from OFS.SimpleItem import SimpleItem
from Globals import DTMLFile
from DateTime import DateTime

from AccessControl import ClassSecurityInfo
from Products.CMFCore.ActionProviderBase import	ActionProviderBase
from Products.CMFCore.ActionInformation	import ActionInformation
from Products.CMFCore.Expression import	Expression
from Products.CMFCore import CMFCorePermissions
import ImageFile
from Products.CMFCore.utils import getToolByName
import re

def initialize(context):
	context.registerClass(Tracker,
		constructors = (manage_tracker_add, ),
)


manage_tracker_add_form	= DTMLFile('dtml/add', globals())

def manage_tracker_add(self, id='tracker', title='', REQUEST=None):
	" "
	self._setObject(id, Tracker(id,	title))
	if REQUEST is not None:
		 REQUEST['RESPONSE'].redirect( self.DestinationURL() + '/manage_main' )



class Tracker(SimpleItem, ActionProviderBase):

	meta_type = 'Tracker object'

	security = ClassSecurityInfo()

	_actions = [		   ActionInformation(id='reports'
				    , title='Daily attendance'
				    , action=Expression(
		  text='string:	${portal_url}/tracker/site_reports')
				    , permissions=(CMFCorePermissions.ModifyPortalContent,)
				    , category='stat'
				    , condition=None
				    , visible=1
			     ),
		   ActionInformation(id='regions'
				    , title='Regions'
				    , action=Expression(
		  text='string:	${portal_url}/tracker/site_regions' )
				    , permissions=(CMFCorePermissions.ModifyPortalContent,)
				    , category='stat'
				    , condition=None
				    , visible=1
			     ),
		   ActionInformation(id='users'
				    , title='Users'
				    , action=Expression(
		  text='string:	${portal_url}/tracker/site_users')
				    , permissions=(CMFCorePermissions.ModifyPortalContent,)
				    , category='stat'
				    , condition=None
				    , visible=1
			     ),
		   ActionInformation(id='pages'
				    , title='Pages_mul'
				    , action=Expression(
		  text='string:	${portal_url}/tracker/site_pages')
				    , permissions=(CMFCorePermissions.ModifyPortalContent,)
				    , category='stat'
				    , condition=None
				    , visible=1
			     ),
# DO NOT DELETE THIS !!!!
#		   ActionInformation(id='common'
#				    , title='Common data'
#				    , action=Expression(
#		  text='string:	${portal_url}/tracker/statistics_manage')
#				    , permissions=(CMFCorePermissions.ModifyPortalContent,)
#				    , category='stat'
#				    , condition=None
#				    , visible=1
#			     ),
#		   ActionInformation(id='reports2'
#				    , title='Reports2'
#				    , action=Expression(
#		  text='string:	${portal_url}/tracker/site_reports2')
#				    , permissions=(CMFCorePermissions.ModifyPortalContent,)
#				    , category='stat'
#				    , condition=None
#				    , visible=1
#			     ),
# /DO NOT DELETE THIS !!!!
		  ]

	manage_options =  (
		{'label': 'View',		'action': 'view'},
		{'label': 'Users',		'action': 'edit_users'},
		{'label': 'Pages',		'action': 'edit_pages'},
		{'label': 'Groups(regions)',	'action': 'edit_regions'},
		{'label': 'Reports',	'action': 'reports'},
		{'label': 'Reports2',	'action': 'reports2'},
		{'label': 'Reports3',	'action': 'reports3'},
		)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent
			, 'edit_users'
			, 'edit_pages'
			, 'edit_regions'
			, 'view'
			, 'reports'
			, 'reports2'
			, 'reports3'
			, 'index_html'
			, 'navigation_tabs'
			, 'site_pages'
			, 'site_reports'
			, 'site_regions'
			, 'site_reports2'
			, 'site_users'
			, 'statistics_manage')

	edit_users = DTMLFile('dtml/users', globals())
	edit_pages = DTMLFile('dtml/pages', globals())
	edit_regions = DTMLFile('dtml/regions',	globals())
	view  =	DTMLFile('dtml/view', globals())
	reports	= DTMLFile('dtml/reports', globals())
	reports2 = DTMLFile('dtml/reports2', globals())
	reports3 = DTMLFile('dtml/reports3', globals())
	index_html = DTMLFile('skins/tracker/site_reports', globals())

	pic1 = ImageFile.ImageFile( 'www/pic1x1.gif', globals())
	pic2 = ImageFile.ImageFile( 'www/pic1x1_2.gif',	globals())
	pic3 = ImageFile.ImageFile( 'www/pic1x1_3.gif',	globals())

	navigation_tabs= DTMLFile('skins/tracker/navigation_tabs', globals())
	site_pages= DTMLFile('skins/tracker/site_pages', globals())
	site_reports= DTMLFile('skins/tracker/site_reports', globals())
	site_regions= DTMLFile('skins/tracker/site_regions', globals())
	site_reports2= DTMLFile('skins/tracker/site_reports2', globals())
	site_users= DTMLFile('skins/tracker/site_users', globals())
	statistics_manage= DTMLFile('skins/tracker/statistics_manage', globals())

	def __init__( self, id,	title):
		""" constructor	"""
		self.id	= id
		self.title = title

		self._active = 1

		# page_all_data	= {page_name :
		# {(year*10000 + hour from the beginning of the year) : number 
		#  of visits in this hour by all users} }
		self._page_all_data = {}

		# page_user_data = {page_name :	{ username :{hour : count} } }
		self._page_user_data = {}

		# list of pages present in statistics
		self._trackable_pages =	[]
		# list of users present in statistics
		self._users = []

		self._regions =	{}  #id:( startIP, endIP, descr )
		#default values:

		#The whole IPv4	address	space
		self._regions['IANA-BLK'] = (0L,
			255255255255L, 'The whole IPv4 address space')
		self._regions['RU-ETEL-971224']	= (195038032000L,
			195038063255L,	'Ekaterinburg Telegraph')
		self._regions['RU-ETEL-980311']	= (212220000000L,
			212220255255L, 'Uraltelecom')
		self._regions['RU-URALWES-970324'] = (195064192000L,
			195064223255L, 'UralWES')

		self._untrackable_pages	= []

		self._untrackable_users	= []

		#hour:[hosts] -	for all	the site
		self._last_day_hosts = {}
		
		self._hosts_count = {}

		# there are differentials betwen internal and
		# external sites
		self.port_url = self.pub_url = self.site_url = None


	def manage_afterAdd(self, item, container):
		""" Get site and public URLs"""
		url_tool = getToolByName(self, 'portal_url')
		portal = url_tool.getPortalObject()
		self.port_url = portal.absolute_url(1)
		go = getattr(portal, 'go', None)

		if go:
			self.pub_url = go.absolute_url(1)
			self.site_url = go.getSiteUrl()[1:]
		else:
			self.site_url = self.pub_url = ' '

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'cutPortalUrl')
	def cutPortalUrl(self, item):
		"""Return URL with trimmed portal URL"""
		result = str(item).replace( self.port_url, '')
		return result

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'getParentURL')
	def getParentURL(self, item):
		"""Return parent URL of given child URL"""
		item = str(item).replace( self.pub_url, self.site_url)
		result = '/'.join( item.split('/')[:-1])
		if result[0] != '/':
			result = '/' + result
		return result

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'getID')
	def getID(self, item):
		"""Return just last part of path (document id)"""
		item = str(item)
		item.replace( self.pub_url, self.site_url, 1 )
		data = item.split('/')
		if len(data):
			id = data[len(data)-1]
		else:
			id = item
		return id


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'listActions')
	def listActions(self, info=None):
		"""
		Return actions provided	by tool.
		"""
		return self._actions

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'isActive')
	def isActive(self):
		"""Return true if tracker is active"""
		return self._active

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'users')
	def users(self):
		"""Return list of users"""
		return self._users

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'trackable_pages')
	def trackable_pages(self):
		"""Return list of trackable pages"""
		return self._trackable_pages

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'untrackable_pages')
	def untrackable_pages(self):
		"""Return list of untrackable pages"""
		return self._untrackable_pages

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'untrackable_users')
	def untrackable_users(self):
		"""Return list of untrackable users"""
		return self._untrackable_users

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'getRegions')
	def getRegions(self):
		"""Return list of region"""
		result = {}
		regs = self._regions
		for key	in self._regions.keys():
			start = '000000000000'[len(str(regs[key][0])):] + str(regs[key][0])
			end = '000000000000'[len(str(regs[key][1])):] + str(regs[key][1])
			start_parts = re.findall(r'\d{3,3}', start )
			end_parts   = re.findall(r'\d{3,3}', end )
			start = '.'.join( map ( lambda x: re.sub( r'^0{1,2}', '', x), start_parts ) )
			end = '.'.join( map ( lambda x: re.sub( r'^0{1,2}', '', x), end_parts ) )
			result[key] = (start, end, regs[key][2])
		return result

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'del_regions')
	def del_regions(self, region_key_del_data=[],	REQUEST=None):
		"""Delete information about region (mask and name) by mask"""
		if region_key_del_data:
			for reg_key in region_key_del_data:
				if self._regions.get(reg_key, None) is not None	and reg_key!='IANA-BLK':
					del (self._regions[ reg_key ] )
		self._p_changed	= 1

		if (REQUEST is not None) and REQUEST.get('HTTP_REFERER', None) is not None:
				REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'add_regions')

	def add_regions(self, name=None, begin=None, end=None, descr=None, REQUEST=None):
		"""Add information about region"""
		if name	and begin and end and descr:
			try:
				begin_long = long ( ''.join( map( lambda x: '000'[len(x):] + x,
							begin.split('.') ) ) )
			except:
				return 'Start field invalid format'
			try:
			
				end_long = long	( ''.join( map(	lambda x: '000'[len(x):] + x,
							end.split('.') ) ) )
			except:
				return 'End field invalid format'
			self._regions[name] = (begin_long, end_long, descr)
			self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'del_users')
	def del_users(self, users_list=None, completely=None, REQUEST=None):
		"""Remove data about given users"""

		if not users_list:
			users_list = []

		# clear	all data in pages statistics about given users
		for page in self._trackable_pages:
			for user in users_list:
				if (self._page_user_data.get( page , None) is None):
					continue
				if (self._page_user_data[page].get( user, None)	is None):
					continue

				for hour in self._page_user_data[page][user].keys():
				       if (self._page_all_data.get(page, None) is not None) and	\
						(self._page_all_data[page].get(hour, None) is not None):
						self._page_all_data[page][hour]	-= self._page_user_data[page][user][hour]
						if self._page_all_data[page][hour] < 0:
							self._page_all_data[page][hour]	= 0

				del (self._page_user_data[page][user])

		for user in users_list:
			try:
				self._users.remove(user)
			except:
				pass


		if completely:
			#      
			for user in users_list:
				if not (user in	self._untrackable_users):
					self._untrackable_users.append(user)

		self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'resume_users')
	def resume_users(self, resume_users_list=None, REQUEST=None):
		"""Resume given	users (track them in future)"""

		if not resume_users_list:
			resume_users_list = []

		for resume_user	in resume_users_list:
			try:
				self._untrackable_users.remove(	resume_user )
			except:
				pass

		self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'del_pages')
	def del_pages(self, pages_list=None, completely	= None,	REQUEST=None):
		"""Remove data about given pages"""

		if not pages_list:
			pages_list = []

		for page in pages_list:
			if self._page_all_data.get( page , None) is not	None:
				del (self._page_all_data[page])

			if self._page_user_data.get( page , None) is not None:
				del (self._page_user_data[page])
				try:
					self._trackable_pages.remove(page)
				except:
					pass
			if completely and ( page not in	self._untrackable_pages	):
					self._untrackable_pages.append(page)


		# TODO:	,  	 ,    v  


		self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'resume_pages')
	def resume_pages(self, resume_pages_list=None, REQUEST=None):
		"""Resume given	pages (track them in future)"""
		if not resume_pages_list:
			resume_pages_list = []


		for resume_page	in resume_pages_list:
			try:
				self._untrackable_pages.remove(	resume_page )
			except:
				pass

		self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'NumHostsForToday')
	def NumHostsForToday(self):
		"""Return EXACTLY number of unique hosts visit us today"""
		today = DateTime()
		h1 = int (     today.year()*10000 +     today.dayOfYear()*24 )
		h2 = h1 + 23
		hosts_count = 0
		hosts = {}
		
		for hour in range(h1, h2):
			for ip in self._last_day_hosts.get( hour , []):
				hosts[ ip ] = 1
		return len ( hosts.keys() )

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'NumHostsForYesterday')
	def NumHostsForYesterday(self):
		"""Return EXACTLY number of unique hosts visit us yesterday"""
		today = DateTime()
		#h2 = int (     today.year()*10000 +     today.dayOfYear()*24 )
		h1 = int ( (today-1).year()*10000 + (today-1).dayOfYear()*24 )
		h2 = h1 + 23
		hosts_count = 0
		hosts = {}
		
		for hour in range(h1, h2):
			for ip in self._last_day_hosts.get( hour , []):
				hosts[ ip ] = 1
		return len ( hosts.keys() )

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'NumHostsForHour')
	def NumHostsForHour(self, year, month, day, hour):
		"""Return number of hosts visited us in given hour"""
		date = DateTime( year, month, day )
		h1 = int (date.year()*10000+date.dayOfYear()*24	+ hour)
		return self._hosts_count.get( h1 , 0 )

	security.declarePublic(	'track_page' )
	def track_page(self, url=None, REQUEST=None):
		"""
		Update unique IPs in current hour depending on visitor's IP 
		(for whole site), number of user's visits for given page in 
		current hour.
		"""
		if not self._active:
			return

		if (REQUEST is None) or	(url is	None):
			return

		cur_page = str(url)
		IP = str(REQUEST['REMOTE_ADDR'])
		
		## may be move it after checking untrackable pages
		
		cur_time = DateTime()
		hour = int ( cur_time.year()*10000+cur_time.dayOfYear()*24 + cur_time.hour())
		
		
		keys = self._last_day_hosts.keys()
		keys.sort()
		
		if len(keys) and hour > keys[len(keys)-1] and len(keys) >= 48:
			# new key will be added so drop oldest
			del( self._last_day_hosts[keys[0]] )
		
		if self._last_day_hosts.get( hour , None) is None:
			self._last_day_hosts[ hour ] = []
			self._hosts_count[hour]= 0
		if  IP not in  self._last_day_hosts[hour]:
			self._last_day_hosts[ hour ].append( IP )
			self._hosts_count[hour]+= 1

		

		if cur_page in self._untrackable_pages:
			# don't need to track this page
			return

		user = str(REQUEST.get('AUTHENTICATED_USER', 'Anonymous	User'))

		# if anonymous user => choose group (region)
		if user	== 'Anonymous User':
			user = self._regions['IANA-BLK'][2] #description of IANA-BLK
			user_id	= 'IANA-BLK'
			# convert IP into long int
			ip_long	= long ( ''.join( map( lambda x: '000'[len(x):]	+ x,
							IP.split('.') )	) )
			data = []
			for key	in self._regions.keys():
				cur_start = self._regions[key][0]
				cur_end	  = self._regions[key][1]
				cur_descr = self._regions[key][2]
				last_start = self._regions[user_id][0]
				last_end = self._regions[user_id][1]
				last_descr = self._regions[user_id][2]
				if (cur_start <	ip_long) and (ip_long <	cur_end):
					if ( (cur_start	>= last_start) and \
						(cur_end <= last_end) ):
						#choose	the smallest address interval
						#in which user is located
						user_id	= key
						user = cur_descr
		if user	in self._untrackable_users:
			# don't track this user
			return

		if not (cur_page in self._trackable_pages):
			self._trackable_pages.append(cur_page)

		#have we record about this page?
		if self._page_user_data.get( cur_page, None ) is None:
			self._page_user_data[cur_page] = {}

		if self._page_all_data.get( cur_page, None ) is	None:
			self._page_all_data[cur_page] =	{}

		#have we record about user in page?
		if	self._page_user_data[cur_page].get( user, None ) is None:
			self._page_user_data[cur_page][user] = {}

		#is there record about current hour?
		cur_time = DateTime()
		hour = cur_time.year()*10000+cur_time.dayOfYear()*24 + cur_time.hour()
		hour = int (hour)

		if self._page_all_data[	cur_page ].get(	hour, None ) is	None:
			self._page_all_data[ cur_page ][hour] =	0;

		if self._page_user_data[ cur_page ][user].get( hour, None ) is None:
			self._page_user_data[ cur_page ][user][hour] = 0;


		#update statistics
		self._page_user_data[ cur_page ][user][hour] +=	1
		self._page_all_data[ cur_page ][hour] += 1

		#append current user into self._users
		is_user	= 0
		for username in	self._users:
			if username == user:
				is_user	= 1
				break
		if not is_user:
			self._users.append(user)

		self._p_changed	= 1
		
	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'reset')
	def reset(self,	REQUEST=None):
		"""Reset all tracker data"""
		self._page_all_data ={}
		self._page_user_data = {}
		self._trackable_pages =	[]
		self._users = []
		self._regions =	{}
		self._regions['IANA-BLK'] = (0L,
			255255255255L, 'The whole IPv4 address space')

		self._untrackable_pages	= []
		self._untrackable_users	= []
		
		self._last_day_hosts = {}	#hour:[hosts] -	for all	the site
		self._hosts_count = {}
		
		self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'turn_on_off')
	def turn_on_off(self, on_off=None, REQUEST=None):
		"""Turn	tracker	on and off"""
		if (str(on_off)	== 'on'):
			#try to	turn on
			self._active = 1
		elif (str(on_off) == 'off'):
			#try to	turn off
			self._active = 0
		self._p_changed	= 1
		if (REQUEST is not None) and (REQUEST.get('HTTP_REFERER', None)	is not None):
			REQUEST['RESPONSE'].redirect(str(REQUEST.get('HTTP_REFERER', None)))

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hostsForPeriod')
	def hostsForPeriod(self, hourBegin, hourEnd):
		"""Return sum (DIRTY) of host(by hour) visited our site"""
		keys = self._hosts_count.keys()
		dirty_hosts_num = 0
		for key in keys:
			if (hourBegin<=key) and (key<hourEnd):
				dirty_hosts_num += self._hosts_count[ key ]
		return dirty_hosts_num

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'groupsForPeriod')
	def groupsForPeriod(self, hourBegin, hourEnd, pages=None, users=None):
		"""
		Return number of groups for period, for given pages and users.
		"""
		num_hosts = 0
		
		if pages is None:
			pages =	self._trackable_pages

		if users is None:
			users =	self._users

		next_user = 0
		for user in users:
			for page in pages:
				try:
					hours =	self._page_user_data[ page ][ user ].keys()
				except:
					continue
				hours.sort()
				for hour in hours:
					if (hourBegin <= hour) and (hour < hourEnd):
						if self._page_user_data[ page ][ user ][ hour ]	> 0:
							num_hosts+=1
							next_user = 1
							break
					if hour	>= hourEnd:
						break
				if next_user:
					next_user = 0;
					break
		return num_hosts



	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'HitsForPeriod')
	def HitsForPeriod(self,	hourBegin, hourEnd, pages=None,	users=None):
		"""
		Return number of hits for period, for given pages and users.
		"""

		if pages is None:
			pages =	self._trackable_pages

		num_hits = 0

		if users is None:
			for page in pages:
				try:
					hours =	self._page_all_data[ page ].keys()
				except:
					continue
				hours.sort()
				for hour in hours:
					if hourBegin <=	hour and hour <	hourEnd:
						num_hits += self._page_all_data[ page ][ hour ]
					if hour	>= hourEnd:
						break
		else:
			for user in users:
				for page in pages:
					try:
						hours =	self._page_user_data[ page ][ user ].keys()
					except:
						continue
					hours.sort()
					for hour in hours:
						if hourBegin <=	hour and hour <	hourEnd:
							num_hits += self._page_user_data[ page ][ user ][ hour ]
						if hour	>= hourEnd:
							break

		return num_hits


	security.declareProtected( CMFCorePermissions.View, 'checkRead')
	def checkRead( self, page, user):
		""" Return true	if user	has read page (at least	once)"""
		user_name = user.getUserName()
		return not not self.Statistics(page, user_name)

	security.declareProtected( CMFCorePermissions.View, 'Statistics')
	def Statistics(	self, page, user = None, timeBegin = None, timeEnd = None):
		"""
		T  	page  user	( ,  user  )
		    dateBegin  dateEnd.
		"""

		h_begin	= h_end	= 0
		hourBegin = hourEnd = 0

		# timeBegin  timeEnd -	TT+L  
		#   v ,   0
		if timeBegin is	not None:
			try:
				_timeBegin = DateTime(timeBegin)
				hourBegin = _timeBegin.year()*10000+_timeBegin.dayOfYear()*24 +	_timeBegin.hour()
				hourBegin = int	(hourBegin)
				h_begin	= 1
			except:
				return 0

		if timeEnd is not None:
			try:
				_timeEnd = DateTime(timeEnd)
				hourEnd	= _timeEnd.year()*10000+_timeEnd.dayOfYear()*24	+ _timeEnd.hour()
				hourEnd	= int (hourEnd)
				h_end =	1
			except:
				return 0

		num_visits = 0

		if user	is not None:
			#  	
			if self._page_user_data.get( page, None	) is None:
				#     
				return 0
			if self._page_user_data[ page ].get( user, None	) is None:
				#     
				return 0
			hour_keys = self._page_user_data[ page ][ user ].keys()
			for hour_key in	hour_keys:
				if (h_begin and	(hour_key < hourBegin))	or ( h_end and (hour_key >= hourEnd) ):
					continue
				num_visits += self._page_user_data[ page ][ user ][ hour_key ]
		else:
			#  	 
			if self._page_all_data.get( page, None ) is None:
				#     
				return 0
			hour_keys = self._page_all_data[ page ].keys()
			for hour_key in	hour_keys:
				if (h_begin and	(hour_key < hourBegin))	or ( h_end and (hour_key >= hourEnd) ):
					continue
				num_visits += self._page_all_data[ page	][ hour_key ]

		return num_visits


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'groupsForHour')
	def groupsForHour(self, year, month, day, hour, pages=None, users=None):
		"""Return number of unique groups(users) for given hour, for given pages and users."""
		date = DateTime( year, month, day )
		h1 = int (date.year()*10000+date.dayOfYear()*24	+ hour)
		return self.groupsForPeriod(h1, h1+1, pages, users)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hitsForHour')
	def hitsForHour(self, year, month, day,	hour, pages=None, users=None):
		"""Return number of hits for given hour, for given pages and users."""
		date = DateTime( year, month, day )
		h1 = int (date.year()*10000+date.dayOfYear()*24	+ hour)
		h2 = h1	+ 1
		return self.HitsForPeriod(h1, h2, pages, users)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'HostsSummary')
	def HostsSummary( self):
		"""
		Return tuple, where 1) hosts for today,	2) hosts for yesrerday,
		3) hosts for last week (include	today),	4) hosts for last 30 days (include today).
		"""
		today =	DateTime()
		summary	=[]
		# append hosts for today
		summary.append( self.NumHostsForToday() )

		# append hosts for yesterday
		summary.append( self.NumHostsForYesterday() )

		# h2 - 00:00 of	tomorrow
		h2 = int ( (today+1).year()*10000 + (today+1).dayOfYear()*24 )

		# h1 - 00:00 of	7 days ago
		h1 = int ((today-6).year()*10000 + (today-6).dayOfYear()*24 )
		# append hosts for last	week
		
		keys = self._hosts_count.keys()
		dirty_hosts_num = 0
		for key in keys:
			if (h1<=key) and (key < h2):
				dirty_hosts_num += self._hosts_count[ key ]
		summary.append(	dirty_hosts_num )

		#h2 - 00:00 of	7 days ago
		h2 = h1
		# h1 - 00:00 of	30 days	ago
		
		### -29 or -30???
		h1 = int ((today-29).year()*10000 + (today-29).dayOfYear()*24 )
		
		# append hosts for last	month
		for key in keys:
			if (h1<=key) and (key < h2):
				dirty_hosts_num += self._hosts_count[ key ]
		summary.append(	dirty_hosts_num )

		return tuple( summary )

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'UsersSummary')
	def UsersSummary( self,	pages=None, users=None):
		"""
		Return tuple, where 1) grops for today,	2) hosts for yesrerday,
		3) hosts for last week (include	today),	4) hosts for last 30 days (include today).
		"""
		today =	DateTime()
		# h1 - 00:00 of	today
		h1 = int (today.year()*10000 + today.dayOfYear()*24 )
		# h2 - 00:00 of	tomorrow
		h2 = int ( (today+1).year()*10000 + (today+1).dayOfYear()*24 )
		summary	=[]
		# append hosts for today
		summary.append(	self.groupsForPeriod(h1, h2, pages, users) )

		# h2 - 00:00 of	today
		h2 = h1
		# h1 - 00:00 of	yesterday
		h1 = int ( (today-1).year()*10000 + (today-1).dayOfYear()*24 )
		# append hosts for yesterday
		summary.append(	self.groupsForPeriod(h1, h2, pages, users) )

		# h2 - 00:00 of	tomorrow
		h2 = int ( (today+1).year()*10000 + (today+1).dayOfYear()*24 )

		# h1 - 00:00 of	7 days ago
		h1 = int ((today-6).year()*10000 + (today-6).dayOfYear()*24 )
		# append hosts for last	week
		summary.append(	self.groupsForPeriod(h1, h2, pages, users) )

		# h1 - 00:00 of	30 days	ago
		h1 = int ((today-29).year()*10000 + (today-29).dayOfYear()*24 )
		# append hosts for last	month
		summary.append(	self.groupsForPeriod(h1, h2, pages, users) )

		return tuple( summary )


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hitsSummary')
	def hitsSummary( self, pages=None, users=None):
		"""
		Return tuple, where 1) hits for	today, 2) hits for yesrerday,
		3) hits	for last week (include today), 4) hits for last	30 days	(include today).
		"""

		today =	DateTime()
		# h1 - 00:00 of	today
		h1 = int (today.year()*10000 + today.dayOfYear()*24 )
		# h2 - 00:00 of	tomorrow
		h2 = int ( (today+1).year()*10000 + (today+1).dayOfYear()*24 )
		summary	=[]
		# append hits for today
		summary.append(	self.HitsForPeriod(h1, h2, pages, users) )

		# h2 - 00:00 of	today
		h2 = h1
		# h1 - 00:00 of	yesterday
		h1 = int ( (today-1).year()*10000 + (today-1).dayOfYear()*24 )
		# append hits for yesterday
		summary.append(	self.HitsForPeriod(h1, h2, pages, users) )

		# h2 - 00:00 of	tomorrow
		h2 = int ( (today+1).year()*10000 + (today+1).dayOfYear()*24 )

		# h1 - 00:00 of	7 days ago
		h1 = int ((today-6).year()*10000 + (today-6).dayOfYear()*24 )
		# append hits for last week
		summary.append(	self.HitsForPeriod(h1, h2, pages, users) )

		# h1 - 00:00 of	30 days	ago
		h1 = int ((today-29).year()*10000 + (today-29).dayOfYear()*24 )
		# append hits for last month
		summary.append(	self.HitsForPeriod(h1, h2, pages, users) )
		return tuple( summary )

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'groupsForDay')
	def groupsForDay(self, year, month, day,	pages=None, users=None):
		"""Return number of hosts for given day, for given pages and users."""
		date = DateTime( year, month, day )
		h1 = int (date.year()*10000+date.dayOfYear()*24)
		h2 = h1	+ 24
		return self.groupsForPeriod(h1, h2, pages, users)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hostsForDay')
	def hostsForDay(self, year, month, day):
		"""Return number of hosts for given day."""
		date = DateTime( year, month, day )
		h1 = int (date.year()*10000+date.dayOfYear()*24)
		h2 = h1	+ 24	
		return self.hostsForPeriod(h1, h2)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hitsForDay')
	def hitsForDay(self, year, month, day, pages=None, users=None):
		"""Return number of hits for given day,	for given pages	and users."""
		date = DateTime( year, month, day )
		h1 = int (date.year()*10000+date.dayOfYear()*24)
		h2 = h1	+ 24
		return self.HitsForPeriod(h1, h2, pages, users)


	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'groupsForMonth')
	def groupsForMonth(self, year, month, pages=None, users=None):
		"""Return number of groups for given month, for given pages and users."""
		date = DateTime( year, month, 1)
		h1 = int (date.year()*10000+date.dayOfYear()*24)
		if month == 12:
			year +=1
			month =	0
		date2 =	DateTime (year,	month+1, 1)
		h2 = int (date2.year()*10000+date2.dayOfYear()*24)
		return self.groupsForPeriod(h1, h2, pages, users)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hostsForMonth')
	def hostsForMonth(self,	year, month):
		"""Return number of hosts for given month (for whole site)"""
		date = DateTime( year, month, 1)
		h1 = int (date.year()*10000+date.dayOfYear()*24)
		if month == 12:
			year +=1
			month =	0
		date2 =	DateTime (year,	month+1, 1)
		h2 = int (date2.year()*10000+date2.dayOfYear()*24)
		
		return self.hostsForPeriod( h1, h2)

	security.declareProtected( CMFCorePermissions.ModifyPortalContent, 'hitsForMonth')
	def hitsForMonth(self, year, month, pages=None,	users=None):
		"""Return number of hits for given month, for given pages and users."""
		date = DateTime( year, month ,1)
		h1 = int (date.year()*10000+date.dayOfYear()*24)
		if month == 12:
			year +=1
			month =	0
		date2 =	DateTime (year,	month+1, 1)
		h2 = int (date2.year()*10000+date2.dayOfYear()*24)
		return self.HitsForPeriod(h1, h2, pages, users)